#include <stdio.h>
#include <time.h>
#include <math.h>

#define test_time(op1,n,trials) { \
  clock_t sum_clock = 0, start_clock, diff_clock; \
  printf ("%s\t", #op1); \
  int t,i,j;\
  for(t = 0; t<trials; t++) { \
   start_clock = clock(); \
   for(j = 1; j<=n; j++) \
    for(i = 1; i<=n; i++) \
     op1 \
   diff_clock = clock() - start_clock; \
   printf ("%d\t",diff_clock); \
   sum_clock += diff_clock; \
   } \
  float result_time = 0.0;\
  result_time = 1e9 * sum_clock / n / n / CLOCKS_PER_SEC / trials; \
  printf("%'.2f\n", result_time ); \
  fsync(stdout);\
  fflush(stdout);\
}
  
int main(void)
{
  int v = 0, n = 5000;
  float fa = 0.0,fb = 0.0,fc = 0.0;
  int *aa, *ab, *ac;
  
  printf("CLOCKS_PER_SEC = %d\n",CLOCKS_PER_SEC);
  printf("  (n = %d):\n", n);
  test_time( ; ,n,5);
  test_time( {} ,n,5);
  
  printf("  (n = %d):\n", n);
  printf(" (n = %d):\n", n);
  test_time( v=i; ,n ,5);
  test_time( v=20; ,n ,5);
  
  printf(" (n = %d):\n", n);
  test_time( v++; ,n ,5);
  test_time( v+=20; ,n ,5);
  test_time( v+=i; ,n ,5);
  test_time( v=v+i; ,n ,5);
  test_time( v=i+j; ,n ,5);
  
  printf(" (n = %d):\n", n);
  test_time( v--; ,n ,5);
  test_time( v-=20; ,n ,5);
  test_time( v-=i; ,n ,5);
  test_time( v=v-i; ,n ,5);
  test_time( v=i-j; ,n ,5);
  
  printf(" (n = %d):\n", n);
  test_time( v*=20; ,n ,5);
  test_time( v*=i; ,n ,5);
  test_time( v=v*i; ,n ,5);
  test_time( v=i*j; ,n ,5);
  
  printf(" (n = %d):\n", n);
  test_time( v/=20; ,n ,5);
  test_time( v/=i; ,n ,5);
  test_time( v=v/i; ,n ,5);
  test_time( v=i/j; ,n ,5);
  
  printf("   (n = %d):\n", n);
  test_time( v%=20; ,n ,5);
  test_time( v%=i; ,n ,5);
  test_time( v=v%i; ,n ,5);
  test_time( v=i%j; ,n ,5);
  
  printf("  (n = %d):\n", n);
  test_time( v=i|j; ,n ,5);
  test_time( v=i|45; ,n ,5);
  test_time( v=65|45; ,n ,5);
  test_time( v|=i; ,n ,5);
  test_time( v|=45; ,n ,5);
  
  test_time( v=i&j; ,n ,5);
  test_time( v=i&45; ,n ,5);
  test_time( v=65&45; ,n ,5);
  test_time( v&=i; ,n ,5);
  test_time( v&=45; ,n ,5);

  test_time( v=i^j; ,n ,5);
  test_time( v=i^45; ,n ,5);
  test_time( v=65^45; ,n ,5);
  test_time( v^=i; ,n ,5);
  test_time( v^=45; ,n ,5);

  test_time( v=i<<j; ,n ,5);
  test_time( v=i<<5; ,n ,5);
  test_time( v=65<<5; ,n ,5);
  test_time( v<<=i; ,n ,5);
  test_time( v<<=5; ,n ,5);

  test_time( v=i>>j; ,n ,5);
  test_time( v=i>>5; ,n ,5);
  test_time( v=65>>5; ,n ,5);
  test_time( v>>=i; ,n ,5);
  test_time( v>>=5; ,n ,5);

  aa = (int*) malloc(sizeof(int)*(n+1));
  ab = (int*) malloc(sizeof(int)*(n+1));
  ac = (int*) malloc(sizeof(int)*(n+1));
  printf("   (n = %d):\n", n);
  test_time( aa[0]=20; ,n ,5);
  test_time( aa[0]=i; ,n ,5);
  test_time( aa[i]=20; ,n ,5);
  test_time( aa[i]=i; ,n ,5);
  test_time( aa[0]+=i; ,n ,5);
  test_time( aa[0]-=i; ,n ,5);
  test_time( aa[i]+=i; ,n ,5);
  test_time( aa[i]-=i; ,n ,5);
  printf("# :\n for(i = 1; i<=%d; i++) {ab[i]=i;ac[i]=i;}\n", n);
  {int i;for(i = 1; i<=n; i++) {ab[i]=i;ac[i]=i;}}
  test_time( aa[i]=ab[i]+ac[j]; ,n ,5);
  test_time( aa[i]=ab[i]-ac[j]; ,n ,5);
  test_time( aa[i]=ab[i]*ac[j]; ,n ,5);
  test_time( aa[i]=ab[i]/ac[j]; ,n ,5);
  test_time( aa[i]=ab[i]%ac[j]; ,n ,5);
  n=500;
  printf("  (n = %d):\n", n);
  test_time( for(v=0;v<n;v++) aa[v]=aa[v+1]; ,n ,5);
  free(ac);ac=aa+1;
  printf("#   ac=aa+1:\n %s\n", "free(ac);ac=aa+1;");
  test_time( for(v=0;v<n;v++) aa[v]=ac[v]; ,n ,5);
  test_time( memmove(aa,aa+1,n); ,n ,5);
  test_time( memmove(aa,ac,n); ,n ,5);
  printf("  (n = %d):\n", n);
  test_time( for(v=0;v<n;v++) aa[v]=ab[v]; ,n ,5);
  test_time( memcpy(aa,ab,n); ,n ,5);
  free(aa);
  free(ab);

  n=5000;
  fa=fb=fc=30.30;
  printf("    (n = %d):\n", n);
  printf(" (n = %d):\n", n);
  test_time( fa=i; ,n ,5);
  test_time( fa=20.0; ,n ,5);
  test_time( fa=fc; ,n ,5);
  printf(" (n = %d):\n", n);
  test_time( fa++; ,n ,5);
  test_time( fa+=20.0; ,n ,5);
  test_time( fa+=fb; ,n ,5);
  test_time( fa=fa+fc; ,n ,5);
  test_time( fa=fb+fc; ,n ,5);
  printf(" (n = %d):\n", n);
  test_time( fa--; ,n ,5);
  test_time( fa-=20.0; ,n ,5);
  test_time( fa-=fb; ,n ,5);
  test_time( fa=fa-fc; ,n ,5);
  test_time( fa=fb-fc; ,n ,5);
  printf(" (n = %d):\n", n);
  test_time( fa*=20.0; ,n ,5);
  test_time( fa*=fb; ,n ,5);
  test_time( fa=fa*fc; ,n ,5);
  test_time( fa=fb*fc; ,n ,5);
  printf(" (n = %d):\n", n);
  test_time( fa/=20.0; ,n ,5);
  test_time( fa/=fb; ,n ,5);
  test_time( fa=fa/fc; ,n ,5);
  test_time( fa=fb/fc; ,n ,5);

  printf(" (n = %d):\n", n);
  test_time( if(0);else; ,n ,5);
  test_time( if(-1);else; ,n ,5);
  test_time( if(0); ,n ,5);
  test_time( if(-1); ,n ,5);
  test_time( if(j<i); ,n ,5);
  test_time( v=(j==i?i:j); ,n ,5);
  test_time( v=(j>i?i:j); ,n ,5);
  test_time( v=(j<i?i:j); ,n ,5);
  test_time( v=(0?i:j); ,n ,5);
  test_time( v=(-1?i:j); ,n ,5);
  n=1000;
  printf(" (n = %d):\n", n);
  test_time( v=rand(); ,n ,5);
  test_time( fa=sqrt(i); ,n ,5);
  test_time( fa=sin(i); ,n ,5);
  test_time( fa=sinh(i); ,n ,5);
  test_time( fa=cos(i); ,n ,5);
  test_time( fa=cosh(i); ,n ,5);
  test_time( fa=tan(i); ,n ,5);
  test_time( fa=tanh(i); ,n ,5);
  test_time( fa=asin(i); ,n ,5);
  test_time( fa=asinh(i); ,n ,5);
  test_time( fa=acos(i); ,n ,5);
  test_time( fa=acosh(i); ,n ,5);
  test_time( fa=atan(i); ,n ,5);
  test_time( fa=atanh(i); ,n ,5);
  n=500;
  printf(" (n = %d):\n", n);
  test_time( free(malloc(1)); ,n ,5);
  test_time( free(malloc(2)); ,n ,5);
  test_time( free(malloc(64)); ,n ,5);
  test_time( free(malloc(1024)); ,n ,5);
  test_time( free(malloc(4096)); ,n ,5);
  test_time( free(malloc(65536)); ,n ,5);
  test_time( free(malloc(i)); ,n ,5);
  
  return 0;
}

